﻿using CoreLibrary.Core;
using System.Globalization;

namespace MauiSpark.Convertisseurs
{
    public class CouleurVersCouleurMAUI : IValueConverter
    {
        public static Color Rouge { get; private set; } = Color.FromArgb("#F75353");
        public static Color Vert { get; private set; } = Color.FromArgb("#53F769");
        public static Color Bleu { get; private set; } = Color.FromArgb("#535AF3");
        public static Color Jaune { get; private set; } = Color.FromArgb("#E9FE67");
        public static Color Noir { get; private set; } = Color.FromArgb("#241E1E");
        public static Color Blanc { get; private set; } = Color.FromArgb("#FFFFFF");

        public object Convert(object? value, Type targetType, object? parameter, CultureInfo culture)
        {
            if (value is not Couleur) 
                return Noir;

            switch (value)
            {
                case Couleur.Blanc:
                    return Blanc;
                case Couleur.Bleu:
                    return Bleu;
                case Couleur.Vert:
                    return Vert;
                case Couleur.Rouge:
                    return Rouge;
                case Couleur.Noir:
                    return Noir;
                case Couleur.Jaune:
                    return Jaune;
                default:
                    return Noir;
            }
        }

        public object ConvertBack(object? value, Type targetType, object? parameter, CultureInfo culture)
        {
            if (value is not Color) return Couleur.Noir;

            if (value.Equals(Rouge))
                return Couleur.Rouge;
            if (value.Equals(Vert))
                return Couleur.Vert;
            if (value.Equals(Bleu))
                return Couleur.Bleu;
            if (value.Equals(Jaune))
                return Couleur.Jaune;
            if (value.Equals(Noir))
                return Couleur.Noir;
            if (value.Equals(Blanc))
                return Couleur.Blanc;

            return Couleur.Noir;
        }
    }
}
